> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.navipartner.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.navipartner.com/_mcp/server.

# Reserve Voucher

POST https://api.npretail.app/{tenant}/{environment}/{company}/voucher/{voucherId}/reservation
Content-Type: application/json

Use this endpoint to reserve amount on voucher.

Reference: https://docs.navipartner.com/apis/api-reference/vouchers/voucher/reserve-voucher

## Authentication

- `x-np-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `tenant` (string, required) — Your Entra Tenant ID. [More details.](/paths#1-tenant)
- `environment` (string, required) — Your Business Central Environment. [More details.](/paths#2-environment)
- `company` (string, required) — Your Business Central Company. [More details.](/paths#3-company)
- `voucherId` (UUID, required) — A unique identifier for the voucher

### Body (application/json)

This endpoint expects a ReserveVoucherRequest.

- `documentNo` (string, required) — The document number for which reservation has been done
- `amount` (double, required) — The amount to reserve on voucher

## Response

### 200

- `reservation` (ReserveVoucherResponseDTO, required) — Information about reservation

## Types

### ReserveVoucherResponseDTO

Information about reservation

- `EndingDate` (datetime, required) — The datetime as from which the voucher is no longer valid
- `StartingDate` (datetime, required) — The datetime as from which the voucher is valid
- `amount` (double, required) — The amount remaining on the voucher
- `initialAmount` (double, required) — The initial amount of the voucher
- `referenceNo` (string, required) — A unique reference number for the voucher
- `reservationDocNo` (string, required) — The document number for which reservation has been done
- `reservationId` (UUID, required) — The unique identifier of the reservation
- `reservedAmount` (double, required) — The amount after reservation is cancelled
- `voucherId` (UUID, required) — A unique identifier for the voucher

## Examples

**Request**

```json
{
  "documentNo": "1000000",
  "amount": 100
}
```

**Response**

```json
{
  "reservation": {
    "EndingDate": "2024-09-17T00:00:00",
    "StartingDate": "2024-09-17T00:00:00",
    "amount": 850,
    "initialAmount": 1000,
    "referenceNo": "2802000002460",
    "reservationDocNo": "1000000",
    "reservationId": "123e4567-e89b-12d3-a456-426614174000",
    "reservedAmount": 200,
    "voucherId": "59adfec5-eca9-47b5-b6bf-6f4222db8de8"
  }
}
```

**SDK Code**

```python Example Reserve Voucher
import requests

url = "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./voucher/59adfec5-eca9-47b5-b6bf-6f4222db8de8/reservation"

payload = {
    "documentNo": "1000000",
    "amount": 100
}
headers = {
    "x-np-api-key": "<NaviPartner API Key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Example Reserve Voucher
const url = 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./voucher/59adfec5-eca9-47b5-b6bf-6f4222db8de8/reservation';
const options = {
  method: 'POST',
  headers: {'x-np-api-key': '<NaviPartner API Key>', 'Content-Type': 'application/json'},
  body: '{"documentNo":"1000000","amount":100}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example Reserve Voucher
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./voucher/59adfec5-eca9-47b5-b6bf-6f4222db8de8/reservation"

	payload := strings.NewReader("{\n  \"documentNo\": \"1000000\",\n  \"amount\": 100\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-np-api-key", "<NaviPartner API Key>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example Reserve Voucher
require 'uri'
require 'net/http'

url = URI("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./voucher/59adfec5-eca9-47b5-b6bf-6f4222db8de8/reservation")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-np-api-key"] = '<NaviPartner API Key>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"documentNo\": \"1000000\",\n  \"amount\": 100\n}"

response = http.request(request)
puts response.read_body
```

```java Example Reserve Voucher
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./voucher/59adfec5-eca9-47b5-b6bf-6f4222db8de8/reservation")
  .header("x-np-api-key", "<NaviPartner API Key>")
  .header("Content-Type", "application/json")
  .body("{\n  \"documentNo\": \"1000000\",\n  \"amount\": 100\n}")
  .asString();
```

```php Example Reserve Voucher
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./voucher/59adfec5-eca9-47b5-b6bf-6f4222db8de8/reservation', [
  'body' => '{
  "documentNo": "1000000",
  "amount": 100
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-np-api-key' => '<NaviPartner API Key>',
  ],
]);

echo $response->getBody();
```

```csharp Example Reserve Voucher
using RestSharp;

var client = new RestClient("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./voucher/59adfec5-eca9-47b5-b6bf-6f4222db8de8/reservation");
var request = new RestRequest(Method.POST);
request.AddHeader("x-np-api-key", "<NaviPartner API Key>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"documentNo\": \"1000000\",\n  \"amount\": 100\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example Reserve Voucher
import Foundation

let headers = [
  "x-np-api-key": "<NaviPartner API Key>",
  "Content-Type": "application/json"
]
let parameters = [
  "documentNo": "1000000",
  "amount": 100
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./voucher/59adfec5-eca9-47b5-b6bf-6f4222db8de8/reservation")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```